	GET	registers.s
	GET	swis.s

ColourPicker_OpenDialogue	*	&47702
ColourPicker_CloseDialogue	*	&47703
ColourPicker_UpdateDialogue	*	&47704
ColourPicker_ReadDialogue	*	&47705
ColourPicker_HelpReply		*	&47707

XColourPicker_OpenDialogue	*	&67702
XColourPicker_CloseDialogue	*	&67703
XColourPicker_UpdateDialogue	*	&67704
XColourPicker_ReadDialogue	*	&67705
XColourPicker_HelpReply		*	&67707

	AREA	|____colourpick_create|, CODE, READONLY
	EXPORT	colourpick_create
colourpick_create

; r0 is flags (5a-559, 5a-560)
; r1 is ^ title
; r2 is x
; r3 is y
; !r13 is ^ model
	LDR	r12, [r13]
	STMFD	r13!, {r4, lr}
	LDR	lr, =colourpick_open

	MOV	r4, r0, LSR#8
	STR	r4, [lr, #0]
	STR	r1, [lr, #4]
	STR	r2, [lr, #8]
	MOV	r2, #&80000000
	STR	r2, [lr, #12]
	MOV	r2, #&7fffffff
	STR	r2, [lr, #16]
	STR	r3, [lr, #20]
	MOV	r2, #0
	STR	r2, [lr, #24]
	STR	r2, [lr, #28]

	LDR	r2, [r12, #0]
	STR	r2, [lr, #32]
	LDR	r2, [r12, #4]
	STR	r2, [lr, #36]
	LDR	r2, [r12, #8]
	STR	r2, [lr, #40]
	LDR	r2, [r12, #12]
	STR	r2, [lr, #44]
	LDR	r2, [r12, #16]
	STR	r2, [lr, #48]
	LDR	r2, [r12, #20]
	STR	r2, [lr, #52]

	MOV	r1, lr
	AND	r0, r0, #255
	SWI	XColourPicker_OpenDialogue
	MOVVS	r0, #0
 [ arm32
	LDMFD	r13!, {r4, pc}
 |
	LDMFD	r13!, {r4, pc}^
 ]

	LTORG

	AREA	|____colourpick_close|, CODE, READONLY
	EXPORT	colourpick_close
colourpick_close

	MOV	r1, r0
	MOV	r0, #0
	SWI	XColourPicker_CloseDialogue
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____colourpick_update|, CODE, READONLY
	EXPORT	colourpick_update
colourpick_update

; r0 is flags (5a-559, 5a-560)
; r1 is ^ title
; r2 is x
; r3 is y
; !r13 is ^ model
; r13!4 is ^ colourpick block
	MOV	r12, r13
	STMFD	r13!,{r4, r5, lr}
	LDR	r5, [r12, #4]
	LDR	r12, [r12]
	LDR	lr, =colourpick_open

	MOV	r4, r0, LSR#8
	AND	r4, r4, #255
	STR	r4, [lr, #0]
	STR	r1, [lr, #4]
	STR	r2, [lr, #8]
	MOV	r2, #&80000000
	STR	r2, [lr, #12]
	MOV	r2, #&7fffffff
	STR	r2, [lr, #16]
	STR	r3, [lr, #20]
	MOV	r2, #0
	STR	r2, [lr, #24]
	STR	r2, [lr, #28]

	LDR	r2, [r12, #0]
	STR	r2, [lr, #32]
	LDR	r2, [r12, #4]
	STR	r2, [lr, #36]
	LDR	r2, [r12, #8]
	STR	r2, [lr, #40]
	LDR	r2, [r12, #12]
	STR	r2, [lr, #44]
	LDR	r2, [r12, #16]
	STR	r2, [lr, #48]
	LDR	r2, [r12, #20]
	STR	r2, [lr, #52]

	MOV	r2, lr
	MOV	r0, r0, LSR#16
	MOV	r1, r5
	SWI	XColourPicker_UpdateDialogue
 [ arm32
	LDMFD	r13!, {r4, r5, pc}
 |
	LDMFD	r13!, {r4, r5, pc}^
 ]

	AREA	colourpick_data, NOINIT
colourpick_open
	%	56
colourpick_model
	%	4

	END
